Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #425 (assigned enhancement)

Opened 16 years ago

Last modified 15 years ago

change modes with wlanconfig (or other method)

Reported by: kelmo Assigned to: mrenzmann (accepted)
Priority: minor Milestone: version 1.0.0 - first stable release
Component: madwifi: tools Version: trunk
Keywords: Cc:
Patch is attached: 0 Pending:

Description

The ability to change modes of an interface without the destroy - create chain of commands would be very nice. Even if it means the creation/destruction is done in one easy command.

Attachments

wlanconfig-mode-change.diff (16.9 kB) - added by strasak@bubakov.net on 10/27/06 11:54:01.
patch for changing VAP mode by wlanconfig also adding some other functionality to wlanconfig
wlanconfig-mode-change-1.1.diff (16.1 kB) - added by strasak@bubakov.net on 10/27/06 13:21:32.
current VAP mode checking + wlaconfig is far less verbose
wlanconfig-mode-change-saveroute-0.02.diff (43.3 kB) - added by strasak@bubakov.net on 02/12/07 14:58:10.
patch now save/restore higher level settings on VAP - IP, aliases, routes
wlanconfig-mode-change-saveroute-0.03.diff (42.8 kB) - added by strasak@bubakov.net on 05/23/07 12:44:16.
fixed patch now save/restore higher level settings on VAP - IP, aliases, routes

Change History

02/24/06 05:52:00 changed by mrenzmann

  • status changed from new to assigned.
  • owner set to mrenzmann.
  • milestone set to version 1.0.0 - first stable release.

02/24/06 05:52:08 changed by mrenzmann

  • status changed from assigned to new.
  • owner deleted.

02/24/06 05:53:10 changed by mrenzmann

  • status changed from new to assigned.
  • owner set to mrenzmann.

Grr... why does Trac remove the "accepted" flag when I reassign the ticket? Gotta patch that...

08/27/06 00:53:48 changed by dyqith

Refer to ticket:176 also

09/08/06 19:59:00 changed by strasak@bubakov.net

I am working on adding this and other features to wlanconfig, hopefully i will upload initial patch during next week. ignuss

10/27/06 11:54:01 changed by strasak@bubakov.net

  • attachment wlanconfig-mode-change.diff added.

patch for changing VAP mode by wlanconfig also adding some other functionality to wlanconfig

10/27/06 12:02:25 changed by ignuss

This patch allow ppl to change mode of already created VAP
for example:

wlanconfig ath0 mode ap will change mode of ath0 to ap mode, checking if interface is not already in ap mode is not done yet, will be added soon. Checking if some other VAP which share same parent wifiX device is implemented ,and if some VAP like that is in STA mode, changing of mode of another VAP to STA mode is refused. Some other functionality is added, take a look at usage of wlanconfig. Some work has to be done - additional checking and etc. - to get all functionality required, but i have wanted to share already done stuff so it could be checked and improved by other ppl too. Consider it alpha. I will continue to work on it and hope that it will be done - in -rc stage - in about 14 days.

Signed-off-by: Pavel Novák <strasak@bubakov.net>

10/27/06 13:21:32 changed by strasak@bubakov.net

  • attachment wlanconfig-mode-change-1.1.diff added.

current VAP mode checking + wlaconfig is far less verbose

10/27/06 13:37:56 changed by strasak@bubakov.net

uploaded new version of patch, some additional sanity checking added and level of verbosity decreased

Signed-off-by: Pavel Novák <strasak@bubakov.net>

11/06/06 10:11:14 changed by strasak@bubakov.net

anyone has tested it since now?

12/14/06 09:30:42 changed by strasak@bubakov.net

no tester yet ? :) Ignuss

12/14/06 09:34:34 changed by strasak@bubakov.net

BTW, i am working on ability of wlanconfig to change mode - internaly by destroying and recreating VAP in another mode - without losing higher level settings - aka statically assigned IP , routes on interface and stuff and basically take another step to make wlanconfig athX mode xyz behave more like iwconfig wlanX mode xyz - but dunno for sure if this is worth the effort. Comments welcome. Ignuss

12/15/06 18:15:34 changed by eanderso

I think that would be a desirable thing. Right now, I have a number of scripts that have to save that information and re-supply it after re-creating the VAP.

Eric

02/12/07 14:52:41 changed by strasak@bubakov.net

Good day to all good ppl.

Recently i finally got enough free time to work on my wlanconfig patch. ATM, work is almost done, what is needed is sanity checking, comments, proper indentation and stuff. Anyway, it works.

Wlanconfig with my patch is able of:

1. changing mode of VAP in one step - for example just type wlanconfig ath0 mode ap( or master) and it will change mode from current one to AP. There is some basic sanity checking, so it will not allow to create second STA mode on interface and stuff, hopefully.

2. list all active VAPs - and their modes - which share underlying wifiX device - by wlanconfig wifi0 list vaps or list vapmodes

3. and it is new, it before calling vap_destroy internally, save IP address of VAP, IP addresses of all it's aliases and all static routes, which are set on particular VAP. This should make life more easy for ppl like us in our community network, where we use mostly static routing and also host routes ( + proxyarp for delivering individual public IPs throught more routers/APs without losing precious public IPs on more proper routing structure and avoiding use of NAT, which is not 100% perfect solution) and also sometimes carry on experiments like changing modes on link - switching from master to managed and etc. - it is strange but we do things like this frequently.

If this sounds interesting to anyone, please let me know, in that case i will rework it a bit to be more proper and more ready for public use. It is relatively big patch, big portion of it is only slightly modified code from ifconfig - code used for saving routing table especially - and it is a bit - or better to say "a bit" :) - bloated, because original code is targeted for more generic usage, so it definitely could be reduced a lot. As always i am signing the patch off.

Signed-off-by: Pavel Novák <strasak@bubakov.net>

02/12/07 14:58:10 changed by strasak@bubakov.net

  • attachment wlanconfig-mode-change-saveroute-0.02.diff added.

patch now save/restore higher level settings on VAP - IP, aliases, routes

05/23/07 12:42:54 changed by strasak@bubakov.net

New version of patch called wlanconfig-mode-change-saveroute-0.03.diff , still bloated, but some stupid mistakes fixed and also it compiles cleanly now. Made against latest svn revision. Debloating and further improvements - making it's behavior even more close to iwconfig's one so it will remember or better to say save/restore also essid and other higher level settings - soon, I hope.

Signed-off-by: Pavel Novák <strasak@bubakov.net>

05/23/07 12:44:16 changed by strasak@bubakov.net

  • attachment wlanconfig-mode-change-saveroute-0.03.diff added.

fixed patch now save/restore higher level settings on VAP - IP, aliases, routes